<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>DB_HTTP Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284024"></a>DB_HTTP Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Andrei</span> <span class="surname">Dragus</span></h3><div class="affiliation"><span class="orgname">OpenSIPS Solutions&gt;<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Andrei</span> <span class="surname">Dragus</span></h3></div></div></div><div><p class="copyright">Copyright © 2009 Voice Sistem SRL</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 8740 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id267976">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id271628">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248018">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248024">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249263">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249285">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249290">1.3.1. <code class="varname">SSL</code>(int)</a></span></dt><dt><span class="section"><a href="#id249614">1.3.2. <code class="varname">cap_raw_quey</code>(int)</a></span></dt><dt><span class="section"><a href="#id248874">1.3.3. <code class="varname">cap_replace</code>(int)</a></span></dt><dt><span class="section"><a href="#id248912">1.3.4. <code class="varname">cap_insert_update</code>(int)</a></span></dt><dt><span class="section"><a href="#id293402">1.3.5. <code class="varname">cap_last_inserted_id</code>(int)</a></span></dt><dt><span class="section"><a href="#id293438">1.3.6. <code class="varname">field_delimiter</code> (str)</a></span></dt><dt><span class="section"><a href="#id293474">1.3.7. <code class="varname">row_delimiter</code> (str)</a></span></dt><dt><span class="section"><a href="#id293511">1.3.8. <code class="varname">quote_delimiter</code> (str)</a></span></dt><dt><span class="section"><a href="#id293548">1.3.9. <code class="varname">value_delimiter</code> (str)</a></span></dt><dt><span class="section"><a href="#id293692">1.3.10. <code class="varname">timeout</code> (int)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293730">1.4. Exported Functions</a></span></dt><dt><span class="section"><a href="#id293736">1.5. Server specifications</a></span></dt><dd><dl><dt><span class="section"><a href="#id293742">1.5.1. Queries</a></span></dt><dt><span class="section"><a href="#http-variables">1.5.2. Variables</a></span></dt><dt><span class="section"><a href="#id294007">1.5.3. Query Types</a></span></dt><dt><span class="section"><a href="#id294112">1.5.4. NULL values in queries</a></span></dt><dt><span class="section"><a href="#id294135">1.5.5. Server Replies</a></span></dt><dt><span class="section"><a href="#id294180">1.5.6. Reply Quoting</a></span></dt><dt><span class="section"><a href="#id294213">1.5.7. Last inserted id</a></span></dt><dt><span class="section"><a href="#id294228">1.5.8. Authentication and SSL</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248001">Setting db_url for a module</a></dt><dt>1.2. <a href="#id249598">Set <code class="varname">SSL</code> parameter</a></dt><dt>1.3. <a href="#id249635">Set <code class="varname">cap_raw_quey</code> parameter</a></dt><dt>1.4. <a href="#id248895">Set <code class="varname">cap_replace</code> parameter</a></dt><dt>1.5. <a href="#id248933">Set <code class="varname">cap_insert_update</code> parameter</a></dt><dt>1.6. <a href="#id293422">Set <code class="varname">cap_last_inserted_id</code> parameter</a></dt><dt>1.7. <a href="#id293458">Set <code class="varname">field_delimiter</code> parameter</a></dt><dt>1.8. <a href="#id293495">Set <code class="varname">row_delimiter</code> parameter</a></dt><dt>1.9. <a href="#id293533">Set <code class="varname">quote_delimiter</code> parameter</a></dt><dt>1.10. <a href="#id293676">Set <code class="varname">value_delimiter</code> parameter</a></dt><dt>1.11. <a href="#id293713">Set <code class="varname">timeout</code> parameter</a></dt><dt>1.12. <a href="#id293760">Example query.</a></dt><dt>1.13. <a href="#id293991">Example query with variables.</a></dt><dt>1.14. <a href="#id294096">More query examples.</a></dt><dt>1.15. <a href="#id294121">NULL query example.</a></dt><dt>1.16. <a href="#id294168">Example Reply.</a></dt><dt>1.17. <a href="#id294200">Quoting Example.</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id267976"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id271628"></a>1.1. Overview</h2></div></div></div><p> This module provides access to a database that is implemented
	as a HTTP server. It may be used in special cases where traversing
	firewalls is a problem, or where data encryption is required.
	</p><p>
	In order to use this module you must have a server that can communicate
	via HTTP or HTTPS with this module that follows exactly the format 
	decribed in the specifications section.
	</p><p>
	The module can provide SSL, authentication, and all the functionalities
	of an opensips db as long as the server supports them ( except result_fetch).
	</p><p>
	There is a slight difference between the url of db_http and
	the urls of the other db modules. The url doesn't have to contain
	the database name. Instead, everything that is after the
	address is considered to be a path to the db resource, it may be
	missing.
	</p><p>
		Even if using HTTPS the url must begin with "http://" , and the
	SSL parameter for the module must be set to 1.
	</p><div class="example"><a name="id248001"></a><p class="title"><b>Example 1.1. Setting db_url for a module</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("presence", "db_url","http://user:pass@localhost:13100")
or
modparam("presence", "db_url","http://user:pass@www.some.com/some/some")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248018"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248024"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		This module does not depend on other modules.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249263"></a>1.2.2. External Libraries or Applications</h3></div></div></div><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>libcurl</em></span>.
			</p></li></ul></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249285"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249290"></a>1.3.1. <code class="varname">SSL</code>(int)</h3></div></div></div><p>
		Whether or not to use SSL.
		</p><p>If value is 1 the module will use https otherwise
		it will use http.
		</p><p>
		<span class="emphasis"><em>	Default value is &#8220;<span class="quote"> 0 </span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id249598"></a><p class="title"><b>Example 1.2. Set <code class="varname">SSL</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_http", "SSL",1)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249614"></a>1.3.2. <code class="varname">cap_raw_quey</code>(int)</h3></div></div></div><p>
		Whether or not the server supports raw queries.
		</p><p>
		<span class="emphasis"><em>	Default value is &#8220;<span class="quote">0</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id249635"></a><p class="title"><b>Example 1.3. Set <code class="varname">cap_raw_quey</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_http", "cap_raw_quey", 1)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248874"></a>1.3.3. <code class="varname">cap_replace</code>(int)</h3></div></div></div><p>
		Whether or not the server supports replace capabilities.
		</p><p>
		<span class="emphasis"><em>	Default value is &#8220;<span class="quote">0</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id248895"></a><p class="title"><b>Example 1.4. Set <code class="varname">cap_replace</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_http", "cap_replace", 1)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248912"></a>1.3.4. <code class="varname">cap_insert_update</code>(int)</h3></div></div></div><p>
		Whether or not the server supports insert_update capabilities.
		</p><p>
		<span class="emphasis"><em>	Default value is &#8220;<span class="quote">0</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id248933"></a><p class="title"><b>Example 1.5. Set <code class="varname">cap_insert_update</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_http", "cap_insert_update", 1)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293402"></a>1.3.5. <code class="varname">cap_last_inserted_id</code>(int)</h3></div></div></div><p>
		Whether or not the server supports last_inserted_id capabilities.
		</p><p>
		<span class="emphasis"><em>	Default value is &#8220;<span class="quote">0</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id293422"></a><p class="title"><b>Example 1.6. Set <code class="varname">cap_last_inserted_id</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_http", "cap_last_inserted_id", 1)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293438"></a>1.3.6. <code class="varname">field_delimiter</code> (str)</h3></div></div></div><p>
		Character to be used to delimit fields in the reply.Only
		one char may be set.
		</p><p>
		<span class="emphasis"><em>Default value is &#8220;<span class="quote">;</span>&#8221;
		</em></span>
		</p><div class="example"><a name="id293458"></a><p class="title"><b>Example 1.7. Set <code class="varname">field_delimiter</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_http", "field_delimiter",";")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293474"></a>1.3.7. <code class="varname">row_delimiter</code> (str)</h3></div></div></div><p>
		Character to be used to delimit rows in the reply.Only
		one char may be set.
		</p><p>
		<span class="emphasis"><em>Default value is &#8220;<span class="quote">\n</span>&#8221;
		</em></span>
		</p><div class="example"><a name="id293495"></a><p class="title"><b>Example 1.8. Set <code class="varname">row_delimiter</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_http", "row_delimiter","\n")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293511"></a>1.3.8. <code class="varname">quote_delimiter</code> (str)</h3></div></div></div><p>
		Character to be used to quote  fields that require quoting
		in the reply.Only one char may be set.
		</p><p>
		<span class="emphasis"><em>Default value is &#8220;<span class="quote">|</span>&#8221;
		</em></span>
		</p><div class="example"><a name="id293533"></a><p class="title"><b>Example 1.9. Set <code class="varname">quote_delimiter</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_http", "quote_delimiter","|")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293548"></a>1.3.9. <code class="varname">value_delimiter</code> (str)</h3></div></div></div><p>
		The delimiter used to separate multiple fields of a single
		variable (see <a class="xref" href="#http-variables" title="1.5.2. Variables">Section 1.5.2, &#8220;Variables&#8221;</a>).
		Only one char may be set.
		</p><p>
		<span class="emphasis"><em>Default value is &#8220;<span class="quote">,</span>&#8221;
		</em></span>
		</p><div class="example"><a name="id293676"></a><p class="title"><b>Example 1.10. Set <code class="varname">value_delimiter</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_http", "value_delimiter",";")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293692"></a>1.3.10. <code class="varname">timeout</code> (int)</h3></div></div></div><p>
		The maximum number of milliseconds that the HTTP ops are allowed to last
		</p><p>
		<span class="emphasis"><em>Default value is &#8220;<span class="quote">30000 ( 30 seconds )</span>&#8221;
		</em></span>
		</p><div class="example"><a name="id293713"></a><p class="title"><b>Example 1.11. Set <code class="varname">timeout</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_http", "timeout",5000)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293730"></a>1.4. Exported Functions</h2></div></div></div>

	This module does not export any functions.
		
</div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293736"></a>1.5. Server specifications</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293742"></a>1.5.1. Queries</h3></div></div></div><p>
		The server must accept queries as HTTP queries.
		</p><p>
		The queries are of 2 types : GET and POST.Both
		set variables that must be interpreted by the server.
		All values are URL-encoded.
		</p><p>
		There are several types of queries and the server can tell
		them apart by the query_type variable. Each type of query uses
		specific variables simillar to those in the opensips db_api.
		</p><div class="example"><a name="id293760"></a><p class="title"><b>Example 1.12. Example query.</b></p><div class="example-contents"><pre class="programlisting">
...
GET /presentity/?c=username,domain,event,expires HTTP/1.1
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="http-variables"></a>1.5.2. Variables</h3></div></div></div><p>
		A description of all the variables. Each variable can have
		either a single value or a comma-separated list of values. Each
		variable has a special meaning and can be used only with
		certain queries.
		</p><p>
		The table on which operations will take place will be encoded
		in the url as the end of the url ( www.some.com/users will point
		to the users table).
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				k=
			</p><p>
				Describes the keys (columns) that will 
				be used for comparison.Can have multiple values.
			</p></li><li><p>
				op=
			</p><p>
				Describes the operators that will 
				be used for comparison.Can have multiple values.
			</p></li><li><p>
				v=
			</p><p>
				Describes the values that columns will be 
				compaired against. Can have multiple values.
			</p></li><li><p>
				c=
			</p><p>
				Describes the columns that will be selected
				from the result.Can have multiple values.
			</p></li><li><p>
				o=
			</p><p>
				The column that the result will be ordered by.
				Has a single value.
			</p></li><li><p>
				uk=
			</p><p>
				The keys(columns) that will be updated.
				Can have multiple values.
			</p></li><li><p>
				uv=
			</p><p>
				The new values that will be put in the columns.
				Can have multiple values.
			</p></li><li><p>
				q=
			</p><p>
				Describes a raw query. Will only be used if
				the server supports raw queries. Has a single
				value.
			</p></li><li><p>
				query_type=
			</p><p>
				Describes the type of the current query.
				Can have a single value as described in the
				Query Types section.Has a single value.
				Will be present in all queries except the
				"SELECT" (normal query).
			</p></li></ul></div><div class="example"><a name="id293991"></a><p class="title"><b>Example 1.13. Example query with variables.</b></p><div class="example-contents"><pre class="programlisting">
...
GET /presentity/?c=username,domain,event,expires HTTP/1.1
GET /version/?k=table_name&amp;v=xcap&amp;c=table_version HTTP/1.1 
...
...
POST /active_watchers HTTP/1.1

k=id&amp;v=100&amp;query_type=insert
...

</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id294007"></a>1.5.3. Query Types</h3></div></div></div><p>
		The types of the queries are described by the
		query_type variable. The value of the variable
		will be set to the exact name of the query.
		</p><p>
		Queries for "SELECT" use GET and the rest use POST
		(insert, update, delete, replace, insert_update).
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				normal query
			</p><p>
				Uses the k, op, v, c and o variables.
				This will not set the query_type variable and
				will use GET.
			</p></li><li><p>
				delete
			</p><p>
				Uses the k, op and v variables.
			</p></li><li><p>
				insert
			</p><p>
				Uses the k and v variables.
			</p></li><li><p>
				update
			</p><p>
				Uses the k,op,v,uk and uv  variables.
			</p></li><li><p>
				replace
			</p><p>
				Uses the k and v  variables. This is an optional
				type of query. If the module is not configured to use it
				it will not.
			</p></li><li><p>
				insert_update
			</p><p>
				Uses the k and v  variables. This is an optional
				type of query. If the module is not configured to use it
				it will not.
			</p></li><li><p>
				custom
			</p><p>
				Uses the q  variable. This is an optional
				type of query. If the module is not configured to use it
				it will not.
			</p></li></ul></div><div class="example"><a name="id294096"></a><p class="title"><b>Example 1.14. More query examples.</b></p><div class="example-contents"><pre class="programlisting">

...
POST /active_watchers HTTP/1.1

k=id&amp;op=%3D&amp;v=100&amp;query_type=delete
...

...
POST /active_watchers HTTP/1.1

k=id&amp;op=%3D&amp;v=100&amp;uk=id&amp;uv=101&amp;query_type=update
...

</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id294112"></a>1.5.4. NULL values in queries</h3></div></div></div><p>
		NULL values in queries are represented as a string of length 1
		containing a single character with value '\0'.
		</p><div class="example"><a name="id294121"></a><p class="title"><b>Example 1.15. NULL query example.</b></p><div class="example-contents"><pre class="programlisting">

...
POST /active_watchers HTTP/1.1

k=id&amp;op=%3D&amp;v=%00&amp;query_type=delete
...


</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id294135"></a>1.5.5. Server Replies</h3></div></div></div><p>
			If the query is ok (even if the answer is empty)
			the server must reply with a 200 OK HTTP reply with
			a body containing the types and values of the columns.
		</p><p>
		The server must reply with a delimiter separated list of
		values and columns.
		</p><p>
			Each element in the list must be seperated from the
			one before it by a field delimiter that must be the same 
			as the one set as a parameter from the script for the module.
			The last element of each line must not be followed by
			a field delimiter, but by a	row delimiter.
		</p><p>
		The first line of the reply must contain a list of the types
		of values of each column. The types can be any from the list:
		integer, string, str, blob, date.
		</p><p>
		Each following line contains the values of each row from the result.
		</p><p>
		If the query produced an error the server must reply with a
		HTTP 500 reply,	or with a corresponding error code (404, 401).
		</p><div class="example"><a name="id294168"></a><p class="title"><b>Example 1.16. Example Reply.</b></p><div class="example-contents"><pre class="programlisting">
...
int;string;blob
6;something=something;1000
100;mine;10002030
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id294180"></a>1.5.6. Reply Quoting</h3></div></div></div><p>
		Because the values may contain delimiters inside,
		the server must perform quoting when necessary (there is no
		problem if it does it even when it is not necessary).
		</p><p>
		A quote delimiter must be defined and must be the same as
		the one set from the script ( by default it is "|" ).
		</p><p>
		If a value contains a field ,  row  or a quote delimiter
		it must be placed under quotes. A quote delimiter inside a value
		must be preceeded by another quote delimiter.
		</p><div class="example"><a name="id294200"></a><p class="title"><b>Example 1.17. Quoting Example.</b></p><div class="example-contents"><pre class="programlisting">
...
int;string;blob
6;|ana;maria|;1000
100;mine;10002030
3;mine;|some||more;|
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id294213"></a>1.5.7. Last inserted id</h3></div></div></div><p>
		This is an optional feature and may be enabled if one wants
		to use it.
		</p><p>
		In order to use this feature the server must place the id
		of the last insert in the 200 reply for each insert query.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id294228"></a>1.5.8. Authentication and SSL</h3></div></div></div><p>
		If the server supports authentication and SSL, the module
		can be enabled to use SSL. Authentication will always be used
		if needed.
		</p><p>
		The module will try to use the most secure type of
		authentication that is provided by the server from:
		Basic, Digest,GSSNEGOTIATE and NTLM.
		</p></div></div></div></div></body></html>
