<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>DBTEXT Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id248845"></a>DBTEXT Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Daniel-Constantin</span> <span class="surname">Mierla</span></h3><code class="email">&lt;<a class="email" href="mailto:miconda@gmail.com">miconda@gmail.com</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Ovidiu</span> <span class="surname">Sas</span></h3><code class="email">&lt;<a class="email" href="mailto:osas@voipembedded.com">osas@voipembedded.com</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Daniel-Constantin</span> <span class="surname">Mierla</span></h3><code class="email">&lt;<a class="email" href="mailto:miconda@gmail.com">miconda@gmail.com</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2003, 2004 FhG FOKUS</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 9528 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id275250">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id284068">1.1. Overview</a></span></dt><dd><dl><dt><span class="section"><a href="#id248002">1.1.1. Design of db_text engine</a></span></dt><dt><span class="section"><a href="#id249333">1.1.2. Internal format of a db_text table</a></span></dt><dt><span class="section"><a href="#id293474">1.1.3. Existing limitations</a></span></dt></dl></dd><dt><span class="section"><a href="#id293486">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id293492">1.2.1. OpenSIPS modules</a></span></dt><dt><span class="section"><a href="#id293514">1.2.2. External libraries or applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id293540">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id293551">1.3.1. <code class="varname">db_mode</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293591">1.4. Exported Functions</a></span></dt><dt><span class="section"><a href="#id293604">1.5. Exported MI Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293609">1.5.1. <code class="varname">dbt_dump</code></a></span></dt></dl></dd><dt><span class="section"><a href="#id293639">1.6. Installation and Running</a></span></dt><dd><dl><dt><span class="section"><a href="#id293688">1.6.1. Using db_text with basic OpenSIPS configuration</a></span></dt></dl></dd></dl></dd><dt><span class="chapter"><a href="#id294525">2. Developer Guide</a></span></dt></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id293433">Sample of a db_text table</a></dt><dt>1.2. <a href="#id293449">Minimal OpenSIPS location db_text table definition</a></dt><dt>1.3. <a href="#id293460">Minimal OpenSIPS subscriber db_text table example</a></dt><dt>1.4. <a href="#id293574">Set <code class="varname">db_mode</code> parameter</a></dt><dt>1.5. <a href="#id293675">Load the db_text module</a></dt><dt>1.6. <a href="#id293704">Definition of 'subscriber' table (one line)</a></dt><dt>1.7. <a href="#id293718">Definition of 'location' and 'aliases' tables (one line)</a></dt><dt>1.8. <a href="#id293732">Definition of 'version' table and sample records</a></dt><dt>1.9. <a href="#id293745">Configuration file</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id275250"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284068"></a>1.1. Overview</h2></div></div></div><p>
		The module implements a simplified database engine based on text
		files. It can be used by OpenSIPS DB interface instead of other
		database module (like MySQL).
	</p><p>
		The module is meant for use in demos or small devices that do not
		support other DB modules. It keeps everything in memory and if you deal
		with large amount of data you may run quickly out of memory. Also, it
		has not implemented all standard database facilities (like order by),
		it includes minimal functionality to work properly with OpenSIPS
	</p><p>
		NOTE: the timestamp is printed in an integer value from time_t
		structure. If you use it in a system that cannot do this conversion,
		it will fail (support for such situation is in to-do list).
	</p><p>
		NOTE: even when is in non-caching mode, the module does not write
		back to hard drive after changes. In this mode, the module checks if
		the corresponding file on disk has changed, and reloads it. The write
		on disk happens at OpenSIPS shut down.
	</p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248002"></a>1.1.1. Design of db_text engine</h3></div></div></div><p>
		The db_text database system architecture:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				a database is represented by a directory in the local file
				system.
				NOTE: when you use <span class="emphasis"><em>db_text</em></span> in OpenSIPS,
				the	database URL for modules must be the path to the directory
				where the table-files are located, prefixed by 
				&#8220;<span class="quote">text://</span>&#8221;, e.g., 
				&#8220;<span class="quote">text:///var/dbtext/opensips</span>&#8221;. If there is no
				&#8220;<span class="quote">/</span>&#8221; after &#8220;<span class="quote">text://</span>&#8221; then
				&#8220;<span class="quote">CFG_DIR/</span>&#8221; is inserted at the beginning of the
				database path. So, either you provide an absolute path to
				database directory or a relative one to &#8220;<span class="quote">CFG_DIR</span>&#8221;
				directory.
				</p></li><li><p>
				a table is represented by a text file inside database directory.
				</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249333"></a>1.1.2. Internal format of a db_text table</h3></div></div></div><p>
		First line is the definition of the columns. Each column must be
		declared as follows:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				the name of column must not include white spaces.
				</p></li><li><p>
				the format of a column definition is: 
				<span class="emphasis"><em>name(type,attr)</em></span>.
				</p></li><li><p>
				between two column definitions must be a white space, e.g., 
				&#8220;<span class="quote">first_name(str) last_name(str)</span>&#8221;.
				</p></li><li><p>
				the type of a column can be: 
					</p><div class="itemizedlist"><ul type="circle"><li><p>
					<span class="emphasis"><em>int</em></span> - integer numbers.
					</p></li><li><p>
					<span class="emphasis"><em>double</em></span> - real numbers with two
					decimals.
					</p></li><li><p>
					<span class="emphasis"><em>str</em></span> - strings with maximum size of 4KB.
					</p></li></ul></div><p>
				</p></li><li><p>
				a column can have one of the attributes: 
					</p><div class="itemizedlist"><ul type="circle"><li><p>
					<span class="emphasis"><em>auto</em></span> - only for 'int' columns,
					the maximum value in that column is incremented and stored
					in this field if it is not provided in queries.
					</p></li><li><p>
					<span class="emphasis"><em>null</em></span> - accept null values in column
					fields.
					</p></li><li><p>
					if no attribute is set, the fields of the column cannot have
					null value.
					</p></li></ul></div><p>
				</p></li><li><p>
				each other line is a row with data. The line ends with
				&#8220;<span class="quote">\n</span>&#8221;.
				</p></li><li><p>
				the fields are separated by &#8220;<span class="quote">:</span>&#8221;.
				</p></li><li><p>
				no value between two ':' (or between ':' and start/end of a row)
				means &#8220;<span class="quote">null</span>&#8221; value.
				</p></li><li><p>
				next characters must be escaped in strings: &#8220;<span class="quote">\n</span>&#8221;,
				&#8220;<span class="quote">\r</span>&#8221;, &#8220;<span class="quote">\t</span>&#8221;, &#8220;<span class="quote">:</span>&#8221;.
				</p></li><li><p>
				 <span class="emphasis"><em>0</em></span> -- the zero value must be escaped too.
				</p></li></ul></div><p>
		</p><div class="example"><a name="id293433"></a><p class="title"><b>Example 1.1. Sample of a db_text table</b></p><div class="example-contents"><pre class="programlisting">
...
id(int,auto) name(str) flag(double) desc(str,null)
1:nick:0.34:a\tgood\: friend
2:cole:-3.75:colleague
3:bob:2.50:
...
</pre></div></div><br class="example-break"><div class="example"><a name="id293449"></a><p class="title"><b>Example 1.2. Minimal OpenSIPS location db_text table definition</b></p><div class="example-contents"><pre class="programlisting">
...
username(str) contact(str) expires(int) q(double) callid(str) cseq(int)
...
</pre></div></div><br class="example-break"><div class="example"><a name="id293460"></a><p class="title"><b>Example 1.3. Minimal OpenSIPS subscriber db_text table example</b></p><div class="example-contents"><pre class="programlisting">
...
username(str) password(str) ha1(str) domain(str) ha1b(str)
suser:supasswd:xxx:alpha.org:xxx
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293474"></a>1.1.3. Existing limitations</h3></div></div></div><p>This database interface don't support the data insertion with
				default values. All such values specified in the database template
				are ignored. So its advisable to specify all data for a column at
				insertion operations.
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293486"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293492"></a>1.2.1. OpenSIPS modules</h3></div></div></div><p>
			The next modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>none</em></span>.
				</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293514"></a>1.2.2. External libraries or applications</h3></div></div></div><p>
			The next libraries or applications must be installed before running
			OpenSIPS with this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>none</em></span>.
				</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293540"></a>1.3. Exported Parameters</h2></div></div></div><p>
			<span class="emphasis"><em>None</em></span>.
	   	</p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293551"></a>1.3.1. <code class="varname">db_mode</code> (integer)</h3></div></div></div><p>
		Set caching mode (0) or non-caching mode (1). In caching mode, data
		is loaded at startup. In non-caching mode, the module check every time
		a table is requested whether the corresponding file on disk has
		changed, and if yes, will re-load table from file.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">0</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id293574"></a><p class="title"><b>Example 1.4. Set <code class="varname">db_mode</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_text", "db_mode", 1)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293591"></a>1.4. Exported Functions</h2></div></div></div><p>
			<span class="emphasis"><em>None</em></span>.
	   	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293604"></a>1.5. Exported MI Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293609"></a>1.5.1. <code class="varname">dbt_dump</code></h3></div></div></div><p>
			Write back to hard drive modified tables.
	   	</p><p>
		Name: <span class="emphasis"><em>dbt_dump</em></span>.
	   	</p><p>Parameters: none</p><p>
	   	MI FIFO Command Format:
	   	</p><pre class="programlisting">
:dbt_dump:_reply_fifo_file_
_empty_line_
		</pre></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293639"></a>1.6. Installation and Running</h2></div></div></div><p>
		Compile the module and load it instead of mysql or other DB modules.
		</p><p>
		REMINDER: when you use <span class="emphasis"><em>db_text</em></span> in OpenSIPS,
		the	database URL for modules must be the path to the directory
		where the table-files are located, prefixed by
		&#8220;<span class="quote">text://</span>&#8221;, e.g., 
		&#8220;<span class="quote">text:///var/dbtext/opensips</span>&#8221;. If there is no &#8220;<span class="quote">/</span>&#8221;
		after &#8220;<span class="quote">text://</span>&#8221; then &#8220;<span class="quote">CFG_DIR/</span>&#8221; is inserted
		at the beginning of the database path. So, either you provide an
		absolute path to database directory or a relative one to 
		&#8220;<span class="quote">CFG_DIR</span>&#8221; directory.
		</p><div class="example"><a name="id293675"></a><p class="title"><b>Example 1.5. Load the db_text module</b></p><div class="example-contents"><pre class="programlisting">
...
loadmodule "/path/to/opensips/modules/db_text.so"
...
modparam("module_name", "database_URL", "text:///path/to/dbtext/database")
...
</pre></div></div><br class="example-break"><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293688"></a>1.6.1. Using db_text with basic OpenSIPS configuration</h3></div></div></div><p>
		Here are the definitions for most important table as well as a basic 
		configuration file to use db_text with OpenSIPS. The table structures
		may change in time and you will have to adjust next examples.
		</p><p>
		You have to populate the table 'subscriber' by hand with user profiles 
		in order to have authentication. To use with the given configuration
		file, the table files must be placed in the '/tmp/opensipsdb' directory.
		</p><div class="example"><a name="id293704"></a><p class="title"><b>Example 1.6. Definition of 'subscriber' table (one line)</b></p><div class="example-contents"><pre class="programlisting">
...
username(str) domain(str) password(str) first_name(str) last_name(str) phone(str) email_address(str) datetime_created(int) datetime_modified(int) confirmation(str) flag(str) sendnotification(str) greeting(str) ha1(str) ha1b(str) perms(str) allow_find(str) timezone(str,null) rpid(str,null)
...
</pre></div></div><br class="example-break"><div class="example"><a name="id293718"></a><p class="title"><b>Example 1.7. Definition of 'location' and 'aliases' tables (one line)</b></p><div class="example-contents"><pre class="programlisting">
...
username(str) domain(str,null) contact(str,null) received(str) expires(int,null) q(double,null) callid(str,null) cseq(int,null) last_modified(str) flags(int) user_agent(str) socket(str) 
...
</pre></div></div><br class="example-break"><div class="example"><a name="id293732"></a><p class="title"><b>Example 1.8. Definition of 'version' table and sample records</b></p><div class="example-contents"><pre class="programlisting">
...
table_name(str) table_version(int)
subscriber:3
location:6
aliases:6
...
</pre></div></div><br class="example-break"><div class="example"><a name="id293745"></a><p class="title"><b>Example 1.9. Configuration file</b></p><div class="example-contents"><pre class="programlisting">
...
#
# $Id$
#
# simple quick-start config script with dbtext
#

# ----------- global configuration parameters ------------------------

#debug=9         # debug level (cmd line: -dddddddddd)
#fork=yes
#log_stderror=no        # (cmd line: -E)

check_via=no    # (cmd. line: -v)
dns=no          # (cmd. line: -r)
rev_dns=no      # (cmd. line: -R)
children=4

listen=10.100.100.1
port=5060

# ------------------ module loading ----------------------------------

# use dbtext database
loadmodule "modules/dbtext/dbtext.so"

loadmodule "modules/sl/sl.so"
loadmodule "modules/tm/tm.so"
loadmodule "modules/rr/rr.so"
loadmodule "modules/maxfwd/maxfwd.so"
loadmodule "modules/usrloc/usrloc.so"
loadmodule "modules/registrar/registrar.so"
loadmodule "modules/textops/textops.so"
loadmodule "modules/textops/mi_fifo.so"

# modules for digest authentication
loadmodule "modules/auth/auth.so"
loadmodule "modules/auth_db/auth_db.so"

# ----------------- setting module-specific parameters ---------------

# -- mi_fifo params --

modparam("mi_fifo", "fifo_name", "/tmp/opensips_fifo")

# -- usrloc params --

# use dbtext database for persistent storage
modparam("usrloc", "db_mode", 2)
modparam("usrloc|auth_db", "db_url", "text:///tmp/opensipsdb")

# -- auth params --
#
modparam("auth_db", "calculate_ha1", 1)
modparam("auth_db", "password_column", "password")
modparam("auth_db", "user_column", "username")
modparam("auth_db", "domain_column", "domain")

# -------------------------  request routing logic -------------------

# main routing logic

route{
    # initial sanity checks -- messages with
    # max_forwards==0, or excessively long requests
    if (!mf_process_maxfwd_header("10")) {
        sl_send_reply("483","Too Many Hops");
        exit;
    };
    if (msg:len &gt;=  max_len ) {
        sl_send_reply("513", "Message too big");
        exit;
    };

    # we record-route all messages -- to make sure that
    # subsequent messages will go through our proxy; that's
    # particularly good if upstream and downstream entities
    # use different transport protocol
    if (!method=="REGISTER") record_route();

    # subsequent messages withing a dialog should take the
    # path determined by record-routing
    if (loose_route()) {
        # mark routing logic in request
        append_hf("P-hint: rr-enforced\r\n");
        route(1);
        exit;
    };

    if (!uri==myself) {
        # mark routing logic in request
        append_hf("P-hint: outbound\r\n");
        route(1);
        exit;
    };

    # if the request is for other domain use UsrLoc
    # (in case, it does not work, use the following command
    # with proper names and addresses in it)
    if (uri==myself) {
        if (method=="REGISTER") {
            # digest authentication
            if (!www_authorize("", "subscriber")) {
                www_challenge("", "0");
                exit;
            };

            save("location");
            exit;
        };

        lookup("aliases");
        if (!uri==myself) {
            append_hf("P-hint: outbound alias\r\n");
            route(1);
            exit;
        };

        # native SIP destinations are handled using our USRLOC DB
        if (!lookup("location")) {
            sl_send_reply("404", "Not Found");
            exit;
        };
    };
    append_hf("P-hint: usrloc applied\r\n");
    route(1);
}

route[1]
{
    # send it out now; use stateful forwarding as it works reliably
    # even for UDP2TCP
    if (!t_relay()) {
        sl_reply_error();
    };
}


...
</pre></div></div><br class="example-break"></div></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id294525"></a>Chapter 2. Developer Guide</h2></div></div></div><p>
	Once you have the module loaded, you can use the API specified by OpenSIPS DB
	interface.
    </p></div></div></body></html>
