<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>dns_cache Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284024"></a>dns_cache Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Vladut-Stefan</span> <span class="surname">Paiu</span></h3><div class="affiliation"><span class="orgname">OpenSIPS Solutions<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Vladut-Stefan</span> <span class="surname">Paiu</span></h3></div></div></div><div><p class="copyright">Copyright © 2012 <a class="ulink" href="http://www.opensips-solutions.com/" target="_top">www.opensips-solutions.com</a></p></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id280443">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id277814">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id284078">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248033">1.2.1. OpenSIPS Modules</a></span></dt></dl></dd><dt><span class="section"><a href="#id248940">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249290">1.3.1. <code class="varname">cachedb_url</code> (string)</a></span></dt><dt><span class="section"><a href="#id249261">1.3.2. <code class="varname">blacklist_timeout</code> (int)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249582">1.4. Exported Functions</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248005">Set <code class="varname">cachedb_url</code> parameter</a></dt><dt>1.2. <a href="#id249272">Set <code class="varname">blacklist_timeout</code> parameter</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id280443"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id277814"></a>1.1. Overview</h2></div></div></div><p>
		This module is an implementation of a cache system designed for DNS records.
		For succesfull DNS queries of all types, the module will store in a cache/db
		backend the mappings, for TTL number of seconds received in the DNS answer.
		Failed DNS queries will also be stored in the back-end, with a TTL that can be
		specified by the user.
		The module uses the Key-Value interface exported from the core.
	</p><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284078"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248033"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		A cachedb_* type module must be loaded before loading
		the dns_cache module.
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248940"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249290"></a>1.3.1. <code class="varname">cachedb_url</code> (string)</h3></div></div></div><p>
			The url of the key-value back-end that will be used
			for storing the DNS records.
		</p><div class="example"><a name="id248005"></a><p class="title"><b>Example 1.1. Set <code class="varname">cachedb_url</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
#use internal cachedb_local module
modparam("dns_cache", "cachedb_url","local://"); 
#use cachedb_memcached module with memcached server at 192.168.2.130
modparam("dns_cache", "cachedb_url","memcached://192.168.2.130:8888/"); 
...
		</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249261"></a>1.3.2. <code class="varname">blacklist_timeout</code> (int)</h3></div></div></div><p>
			The number of seconds that a failed DNS query will be kept in cache.
			Default is 3600.
		</p><div class="example"><a name="id249272"></a><p class="title"><b>Example 1.2. Set <code class="varname">blacklist_timeout</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("dns_cache", "blacklist_timeout",7200); # 2 hours
...
		</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249582"></a>1.4. Exported Functions</h2></div></div></div><p>The module does not export functions to be used
		in configuration script.</p></div></div></div></body></html>
